$(document).ready(function() {

    // filter input elements
    var $slider = $(".filter #slider-range"),
        $title = $(".filter.title input"),
        $movies = $(".movie");

    // get all relevant movie data and save in array
    var movieData = [];
    getMovieData();

    // initialize jqueryUI range slider 
    $slider.slider({
        range: true,
        min: 0,
        max: 300,
        values: [ 0, 300 ],
        slide: function( event, ui ) {
            $("#range").html(ui.values[0] + " min. to " + ui.values[1] + " min." );
        },
        stop: function( event, ui ) {
            filterByRuntime(ui.values[0], ui.values[1]);
        }
    });


    // show selected range initially
    $("#range").html($slider.slider( "values", 0 ) +
        " min. to " + $slider.slider( "values", 1 ) + " min." );


    // initialize jqueryUI autocomplete widget
    $title.autocomplete({
        source: movieData,
        select: function(event, ui) {
            filterByName(ui.item.value);
        }
    });

    // sort on input event
    $title.on("input change", function() {
        filterByName($title.val());
    });

    // get movie data initially
    function getMovieData() {
        // go through all movies
        $('.movie').each(function() {

            // get title from current DOM Element
            var t = $(this).find('.inline-sort-params span[name=alpha]').data('value');

            // new movie object
            var movie = {};
            // add title
            movie.value = t;

            movieData.push(movie);
        });
    }

    // filter movie entries by name
    function filterByName(input) {
        // check all movienames for entered string
        for (var i = 0; i < $movies.length; i++) {
            if ($movies.eq(i).find('.title a').html().toLowerCase().indexOf(input.toLowerCase()) == -1) {
                $movies.eq(i).addClass('hiddenName');
            } else {
                $movies.eq(i).removeClass('hiddenName');
            }
        }
    }

    /*
    * I use two different classes for hiding entries : hiddenName and hiddenRuntime.
    * This way, the two filter functions do not interfere in any unwanted way
    */

    // filter movie entries by runtime
    function filterByRuntime(min, max) {
        // go through all movies and get runtime
        for (var i = 0; i < $movies.length; i++) {
            var runtime = $movies.eq(i).find('.inline-sort-params span[name=runtime]').data('value');

            // check if runtime is in between min and max value
            if (runtime < min || runtime > max) {
                $movies.eq(i).addClass('hiddenRuntime');
            } else {
                $movies.eq(i).removeClass('hiddenRuntime');
            }
        }
    }
});



